"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.QueryAutoCompleter = void 0;
const util_1 = require("./util");
class QueryAutoCompleter {
    constructor(version, textCompleter, fields) {
        this.version = version;
        this.textCompleter = textCompleter;
        this.fields = fields;
        this.getCompletions = (editor, session, position, prefix, done) => {
            if (prefix === '')
                return done(null, []);
            const currentToken = session.getTokenAt(position.row, position.column);
            if ((currentToken === null || currentToken === void 0 ? void 0 : currentToken.type) === 'string') {
                return this.textCompleter.getCompletions(editor, session, position, prefix, done);
            }
            const expressions = util_1.MATCH_COMPLETIONS.concat(this.fields);
            done(null, (0, util_1.filter)(this.version, expressions, prefix));
        };
    }
    update(fields) {
        this.fields = fields;
    }
}
exports.QueryAutoCompleter = QueryAutoCompleter;
//# sourceMappingURL=query-autocompleter.js.map