"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.mongodbAceThemeCssText = exports.mongodbAceThemeCssClass = void 0;
const compass_components_1 = require("@mongodb-js/compass-components");
const mongodbAceThemeCssClass = 'ace-mongodb';
exports.mongodbAceThemeCssClass = mongodbAceThemeCssClass;
const errorColor = encodeURIComponent(compass_components_1.palette.red.base);
const errorColorDarkMode = encodeURIComponent(compass_components_1.palette.red.light1);
const foldColor = encodeURIComponent(compass_components_1.palette.black);
const foldColorDarkMode = encodeURIComponent(compass_components_1.palette.white);
const css = String.raw;
const mongodbAceThemeCssText = css `
  .ace-mongodb {
    --editor-color: ${compass_components_1.palette.black};
    --editor-background: ${compass_components_1.palette.gray.light3};

    --gutter-color: ${compass_components_1.palette.gray.base};
    --gutter-background: ${compass_components_1.palette.gray.light3};
    --gutter-active-line-background: ${compass_components_1.palette.gray.light2};

    --cursor-color: ${compass_components_1.palette.gray.base};

    --print-margin-background: ${compass_components_1.palette.gray.light2};

    --indent-guide-from: transparent;
    --indent-guide-to: ${compass_components_1.palette.gray.light1};

    --marker-active-line-background: ${compass_components_1.palette.gray.light2};
    --marker-focus-active-line-background: ${compass_components_1.palette.gray.light2};
    --marker-selection-background: ${compass_components_1.palette.blue.light2};
    --marker-step-background: ${compass_components_1.palette.yellow.light2};
    --marker-stack-background: ${compass_components_1.palette.green.base};
    --marker-bracket-border-color: ${compass_components_1.palette.gray.light1};
    --marker-selected-word-background: transparent;

    --keyword-color: ${compass_components_1.palette.gray.base};
    --string-color: ${compass_components_1.palette.blue.base};
    --string-regexp-color: ${compass_components_1.palette.blue.base};
    --boolean-color: ${compass_components_1.palette.blue.base};
    --constant-numeric-color: ${compass_components_1.palette.blue.base};
    --constant-builtin-color: ${compass_components_1.palette.blue.light1};
    --variable-class-color: ${compass_components_1.palette.green.dark2};
    --variable-instance-color: ${compass_components_1.palette.green.dark2};
    --variable-language-color: ${compass_components_1.palette.blue.light1};
    --support-function-color: ${compass_components_1.palette.blue.light1};
    --comment-color: ${compass_components_1.palette.gray.base};
    --invisible-color: ${compass_components_1.palette.gray.light1};

    --autocomplete-color: ${compass_components_1.palette.black};
    --autocomplete-background: ${compass_components_1.palette.gray.light3};
    --autocomplete-border-color: ${compass_components_1.palette.gray.light2};
    --autocompletion-highlight-color: ${compass_components_1.palette.green.dark1};
    --autocompletion-marker-active-line-background: ${compass_components_1.palette.gray.light2};
  }

  .ace_dark.ace-mongodb {
    --editor-color: ${compass_components_1.palette.gray.light3};
    --editor-background: ${compass_components_1.palette.gray.dark3};

    --gutter-color: ${compass_components_1.palette.gray.light3};
    --gutter-background: ${compass_components_1.palette.gray.dark3};
    --gutter-active-line-background: ${compass_components_1.palette.gray.dark2};

    --cursor-color: ${compass_components_1.palette.green.base};

    --print-margin-background: ${compass_components_1.palette.gray.light2};

    --indent-guide-from: transparent;
    --indent-guide-to: ${compass_components_1.palette.gray.light1};

    --marker-active-line-background: ${compass_components_1.palette.gray.dark2};
    --marker-focus-active-line-background: ${compass_components_1.palette.gray.dark2};
    --marker-selection-background: ${compass_components_1.palette.gray.dark1};
    --marker-step-background: ${compass_components_1.palette.yellow.light2};
    --marker-stack-background: ${compass_components_1.palette.green.base};
    --marker-bracket-border-color: ${compass_components_1.palette.gray.light1};
    --marker-selected-word-background: transparent;

    --keyword-color: #ff7dc3;
    --string-color: #35de7b;
    --string-regexp-color: #35de7b;
    --boolean-color: #2dc4ff;
    --constant-numeric-color: #ff6f44;
    --constant-builtin-color: ${compass_components_1.palette.blue.light1};
    --variable-class-color: #a5e3ff;
    --variable-instance-color: #a5e3ff;
    --variable-language-color: ${compass_components_1.palette.blue.light1};
    --support-function-color: ${compass_components_1.palette.blue.light1};
    --comment-color: ${compass_components_1.palette.gray.base};
    --invisible-color: ${compass_components_1.palette.gray.dark2};

    --autocomplete-color: ${compass_components_1.palette.gray.light1};
    --autocomplete-background: ${compass_components_1.palette.gray.dark3};
    --autocomplete-border-color: ${compass_components_1.palette.gray.dark1};
    --autocompletion-highlight-color: ${compass_components_1.palette.gray.light3};
    --autocompletion-marker-active-line-background: ${compass_components_1.palette.gray.dark2};
  }

  .ace-mongodb.ace_editor {
    color: var(--editor-color);
    background: var(--editor-background);
    line-height: ${compass_components_1.spacing[3]}px;
  }
  .inline-editor.ace-mongodb.ace_editor {
    background: transparent;
  }
  .ace-mongodb .ace_placeholder {
    margin: 0;
    font-family: inherit;
    font-size: inherit;
    font-style: inherit !important;
    transform: none;
    opacity: 1;
    /* To match ace editor text padding */
    padding: 0 4px !important;
  }
  .ace-mongodb .ace_gutter {
    color: var(--gutter-color);
    background: var(--gutter-background);
  }
  .inline-editor.ace-mongodb .ace_gutter {
    background: inherit;
  }
  .ace-mongodb .ace_gutter-cell {
    /* gutter left padding has to account for error annotation icon size */
    padding-left: ${compass_components_1.spacing[3]}px;
  }
  .ace-mongodb .ace_gutter-cell.ace_error {
    /* leafygreen XWithCircle */
    background-image: url("data:image/svg+xml,%3Csvg xmlns='http://www.w3.org/2000/svg' fill='none' viewBox='0 0 16 16'%3E%3Cpath fill='${errorColor}' fill-rule='evenodd' d='M8 15A7 7 0 1 0 8 1a7 7 0 0 0 0 14zm1.414-9.828a1 1 0 1 1 1.414 1.414L9.414 8l1.414 1.414a1 1 0 1 1-1.414 1.414L8 9.414l-1.414 1.414a1 1 0 1 1-1.414-1.414L6.586 8 5.172 6.586a1 1 0 0 1 1.414-1.414L8 6.586l1.414-1.414z' clip-rule='evenodd'/%3E%3C/svg%3E%0A");
    background-size: 12px;
    background-repeat: no-repeat;
    background-position: ${compass_components_1.spacing[1] / 2}px center;
  }
  /* To change svg foll color, we have to completely replace the background url, this can't be done with css custom properties */
  .ace_dark.ace-mongodb .ace_gutter-cell.ace_error {
    background-image: url("data:image/svg+xml,%3Csvg xmlns='http://www.w3.org/2000/svg' fill='none' viewBox='0 0 16 16'%3E%3Cpath fill='${errorColorDarkMode}' fill-rule='evenodd' d='M8 15A7 7 0 1 0 8 1a7 7 0 0 0 0 14zm1.414-9.828a1 1 0 1 1 1.414 1.414L9.414 8l1.414 1.414a1 1 0 1 1-1.414 1.414L8 9.414l-1.414 1.414a1 1 0 1 1-1.414-1.414L6.586 8 5.172 6.586a1 1 0 0 1 1.414-1.414L8 6.586l1.414-1.414z' clip-rule='evenodd'/%3E%3C/svg%3E%0A");
  }
  .ace-mongodb .ace_fold-widget {
    /* leafygreen CaretDown */
    background-image: url("data:image/svg+xml,%3Csvg xmlns='http://www.w3.org/2000/svg' fill='none' viewBox='0 0 16 16'%3E%3Cpath fill='${foldColor}' d='M8.679 10.796a.554.554 0 0 1-.858 0L4.64 6.976C4.32 6.594 4.582 6 5.069 6h6.362c.487 0 .748.594.43.976l-3.182 3.82z'/%3E%3C/svg%3E%0A");
    background-size: 12px;
    background-repeat: no-repeat;
    background-position: center;
  }
  .ace_dark.ace-mongodb .ace_fold-widget {
    background-image: url("data:image/svg+xml,%3Csvg xmlns='http://www.w3.org/2000/svg' fill='none' viewBox='0 0 16 16'%3E%3Cpath fill='${foldColorDarkMode}' d='M8.679 10.796a.554.554 0 0 1-.858 0L4.64 6.976C4.32 6.594 4.582 6 5.069 6h6.362c.487 0 .748.594.43.976l-3.182 3.82z'/%3E%3C/svg%3E%0A");
  }
  .ace-mongodb .ace_fold-widget.ace_closed {
    /* leafygreen CaretRight */
    background-image: url("data:image/svg+xml,%3Csvg xmlns='http://www.w3.org/2000/svg' fill='none' viewBox='0 0 16 16'%3E%3Cpath fill='${foldColor}' d='M10.796 7.321a.554.554 0 0 1 0 .858l-3.82 3.181c-.382.319-.976.058-.976-.429V4.57c0-.487.594-.748.976-.43l3.82 3.182z'/%3E%3C/svg%3E%0A");
  }
  .ace_dark.ace-mongodb .ace_fold-widget.ace_closed {
    background-image: url("data:image/svg+xml,%3Csvg xmlns='http://www.w3.org/2000/svg' fill='none' viewBox='0 0 16 16'%3E%3Cpath fill='${foldColorDarkMode}' d='M10.796 7.321a.554.554 0 0 1 0 .858l-3.82 3.181c-.382.319-.976.058-.976-.429V4.57c0-.487.594-.748.976-.43l3.82 3.182z'/%3E%3C/svg%3E%0A");
  }
  .ace-mongodb .ace_keyword {
    color: var(--keyword-color);
    font-weight: normal;
  }
  .ace-mongodb .ace_string {
    color: var(--string-color);
  }
  .ace-mongodb .ace_boolean {
    color: var(--boolean-color);
    font-weight: normal;
  }
  .ace-mongodb .ace_constant.ace_numeric {
    color: var(--constant-numeric-color);
  }
  .ace-mongodb .ace_string.ace_regexp {
    color: var(--string-regexp-color);
  }
  .ace-mongodb .ace_variable.ace_class {
    color: var(--variable-class-color);
  }
  .ace-mongodb .ace_constant.ace_buildin {
    color: var(--constant-builtin-color);
  }
  .ace-mongodb .ace_support.ace_function {
    color: var(--support-function-color);
  }
  .ace-mongodb .ace_comment {
    color: var(--comment-color);
    font-style: italic;
  }
  .ace-mongodb .ace_variable.ace_language {
    color: var(--variable-language-color);
  }
  .ace-mongodb .ace_paren {
    font-weight: normal;
  }
  .ace-mongodb .ace_variable.ace_instance {
    color: var(--variable-instance-color);
  }
  .ace-mongodb .ace_constant.ace_language {
    font-weight: bold;
  }
  .ace-mongodb .ace_cursor {
    background: transparent;
    color: var(--cursor-color);
    border-color: var(--cursor-color);
  }
  .ace-mongodb .ace_marker-layer .ace_active-line {
    background: var(--marker-active-line-background);
  }
  .ace-mongodb.ace_focus .ace_marker-layer .ace_active-line {
    background: var(--marker-focus-active-line-background);
  }
  .ace-mongodb .ace_marker-layer .ace_selection {
    background: var(--marker-selection-background);
  }
  .ace-mongodb.ace_nobold .ace_line > span {
    font-weight: normal !important;
  }
  .ace-mongodb .ace_marker-layer .ace_step {
    background: var(--marker-step-background);
  }
  .ace-mongodb .ace_marker-layer .ace_stack {
    background: var(--marker-stack-background);
  }
  .ace-mongodb .ace_marker-layer .ace_bracket {
    margin: 0px;
    border: 1px solid var(--marker-bracket-border-color);
  }
  .ace-mongodb .ace_gutter-active-line {
    background: var(--gutter-active-line-background);
  }
  .ace-mongodb .ace_marker-layer .ace_selected-word {
    background: var(--marker-selected-word-background);
    border: none;
  }
  .ace-mongodb .ace_invisible {
    color: var(--invisible-color);
  }
  .ace-mongodb .ace_print-margin {
    width: 1px;
    background: var(--print-margin-background);
  }
  .ace-mongodb .ace_hidden-cursors {
    opacity: 0;
  }
  .ace-mongodb .ace_indent-guide {
    background: linear-gradient(
        to top,
        var(--indent-guide-from) 0%,
        var(--indent-guide-from) 50%,
        var(--indent-guide-to) 50%,
        var(--indent-guide-to) 100%
      )
      right repeat-y;
    background-size: 1px 2px;
  }
  .ace-mongodb .ace_scroller.ace_scroll-left {
    /* Hide ace's default left box shadow when scrolled. */
    box-shadow: none;
  }

  /* Autocomplete colors */

  /* duplicating class names to override default ace styles */
  .ace-mongodb.ace-mongodb.ace_editor.ace_autocomplete {
    box-sizing: border-box;
    border: 1px solid var(--autocomplete-border-color);
    background-color: var(--autocomplete-background);
    box-shadow: 0 5px 8px 0 rgba(0, 0, 0, 0.5);
    color: var(--autocomplete-color);
    /* line-height: 24px; */
  }
  .ace-mongodb.ace-mongodb.ace_editor.ace_autocomplete
    .ace_completion-highlight {
    color: var(--autocompletion-highlight-color);
    text-shadow: none;
    font-weight: bold;
  }
  .ace-mongodb.ace-mongodb.ace_editor.ace_autocomplete
    .ace_marker-layer
    .ace_active-line {
    background-color: var(--autocompletion-marker-active-line-background);
  }
`;
exports.mongodbAceThemeCssText = mongodbAceThemeCssText;
ace.define('ace/theme/mongodb', ['require', 'exports', 'module', 'ace/lib/dom'], function (acequire, exports) {
    exports.isDark = false;
    exports.cssClass = mongodbAceThemeCssClass;
    exports.cssText = mongodbAceThemeCssText;
    const dom = acequire('../lib/dom');
    dom.importCssString(exports.cssText, exports.cssClass);
});
ace.define('ace/theme/mongodb-dark', ['require', 'exports', 'module', 'ace/lib/dom'], function (acequire, exports) {
    exports.isDark = true;
    exports.cssClass = mongodbAceThemeCssClass;
    exports.cssText = mongodbAceThemeCssText;
    const dom = acequire('../lib/dom');
    dom.importCssString(exports.cssText, exports.cssClass);
});
//# sourceMappingURL=theme.js.map