"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MATCH_COMPLETIONS = exports.filter = void 0;
const mongodb_constants_1 = require("@mongodb-js/mongodb-constants");
const semver_1 = __importDefault(require("semver"));
const filter = (version, entries, prefix) => {
    const parsedVersion = semver_1.default.parse(version);
    return entries.filter((e) => {
        const cleanVersion = parsedVersion
            ? [parsedVersion.major, parsedVersion.minor, parsedVersion.patch].join('.')
            : version;
        return e.value.startsWith(prefix) && semver_1.default.gte(cleanVersion, e.version);
    });
};
exports.filter = filter;
const MATCH_COMPLETIONS = [].concat(mongodb_constants_1.QUERY_OPERATORS, mongodb_constants_1.BSON_TYPES);
exports.MATCH_COMPLETIONS = MATCH_COMPLETIONS;
//# sourceMappingURL=util.js.map