"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ValidationAutoCompleter = void 0;
const mongodb_constants_1 = require("@mongodb-js/mongodb-constants");
const util_1 = require("./util");
class ValidationAutoCompleter {
    constructor(version, textCompleter, fields) {
        this.version = version;
        this.textCompleter = textCompleter;
        this.fields = fields;
        this.getCompletions = (_editor, session, position, prefix, done) => {
            if (prefix === '')
                return done(null, []);
            const currentToken = session.getTokenAt(position.row, position.column);
            if ((currentToken === null || currentToken === void 0 ? void 0 : currentToken.type) === 'string') {
                const strings = [].concat(mongodb_constants_1.BSON_TYPE_ALIASES, this.fields);
                return done(null, (0, util_1.filter)(this.version, strings, prefix));
            }
            const expressions = util_1.MATCH_COMPLETIONS.concat(this.fields, mongodb_constants_1.JSON_SCHEMA);
            return done(null, (0, util_1.filter)(this.version, expressions, prefix));
        };
        this.version = version;
        this.textCompleter = textCompleter;
        this.fields = fields;
    }
    update(fields) {
        this.fields = fields;
    }
}
exports.ValidationAutoCompleter = ValidationAutoCompleter;
//# sourceMappingURL=validation-autocompleter.js.map