import React from 'react';
import 'ace-builds';
import type { IAceEditorProps, IAceOptions } from 'react-ace';
import 'ace-builds/src-noconflict/ext-language_tools';
import 'ace-builds/src-noconflict/mode-javascript';
import 'ace-builds/src-noconflict/mode-json';
import 'ace-builds/src-noconflict/mode-csharp';
import 'ace-builds/src-noconflict/mode-python';
import 'ace-builds/src-noconflict/mode-java';
import 'ace-builds/src-noconflict/mode-ruby';
import 'ace-builds/src-noconflict/mode-rust';
import 'ace-builds/src-noconflict/mode-golang';
import 'ace-builds/src-noconflict/mode-php';
import './ace';
declare const EditorVariant: {
    readonly Shell: "Shell";
    readonly EJSON: "EJSON";
    readonly Generic: "Generic";
};
export declare type EditorProps = {
    variant: keyof typeof EditorVariant;
    text?: string;
    id?: string;
    options?: Omit<IAceOptions, 'readOnly' | 'fontFamily' | 'fontSize' | 'enableLiveAutocompletion'>;
    readOnly?: boolean;
    completer?: unknown;
    'data-testid'?: string;
    onChangeText?: (text: string, event?: any) => void;
    darkMode?: boolean;
    editorClassName?: string;
} & Omit<IAceEditorProps, 'onChange' | 'value' | 'theme'>;
declare function BaseEditor({ text, variant, options, readOnly, id, name, commands: _commands, onChangeText, completer, 'data-testid': dataTestId, onFocus, darkMode: _darkMode, className, editorClassName, ...aceProps }: EditorProps): React.ReactElement;
declare function setEditorValue(element: HTMLElement, value: string): void;
declare const EditorTextCompleter: any;
export { BaseEditor, EditorVariant, EditorTextCompleter, setEditorValue };
//# sourceMappingURL=base-editor.d.ts.map